/*
                StartAndEndPoint l1 = parseArray[i];
                StartAndEndPoint l2 = parseArray[i+ 1];
                //CHECK WHICH line starts after the other
                //If l1 is starting after, then comparisons are based around l1.s
                //System.out.println("l1: " + l1.getP1().x);
                //System.out.println("l2: " + l2.getP1().x);

                System.out.println("1.0: L1S: " + l1.getP1().x + " larger than L2S: " + l2.getP1().x);
                if(l1.getP1().x > l2.getP1().x) {
                    System.out.println("1.1: Comparing L1S: " + l1.getP1().x + " less than L2E: " + l2.getP2().x);
                    if (l1.getP1().x < l2.getP2().x) {
                        //AND
                        System.out.println("1.2: Comparing L1S: " + l1.getP1().x + " larger than L2S: " + l2.getP1().x);
                        if (l1.getP1().x > l2.getP1().x) {
                            System.out.println("1: Success. NEXT");
                            //IT IS INTERSECTED
                            continue;
                        }
                        else {
                            //FAILED SECOND COMPARISON
                            System.out.println("1: Fail");
                        }
                    }
                    else {
                        System.out.println("Checking other line");
                    }
                    System.out.println("2.0: L2S: " + l2.getP1().x + " larger than  L1S: " + l1.getP1().x);
                }
                //If l2 is starting after, then comparisons are based around l2.s
                else if(l2.getP1().x > l1.getP1().x) {
                    System.out.println("2.1: Comparing L2S: " + l1.getP1().x + " less than L1E: " + l2.getP2().x);
                    if (l2.getP1().x < l1.getP2().x) {
                        //AND
                        System.out.println("2.2: Comparing L2S: " + l2.getP1().x + " larger than L1S: " + l1.getP1().x);
                        if (l2.getP1().x > l1.getP1().x) {
                            System.out.println("2: Success");
                            //IT IS INTERSECTED
                            //continue;
                        }
                        else {
                            //FAILED SECOND COMPARISON
                            System.out.println("2: Fail");
                            //return false;
                        }
                    }
                    else {
                        System.out.println("Failed second comparison RETURN FALSE");
                        return false;
                    }
                    //return false;
                }
                else{
                    System.out.println("NEITHER RETURN FALSE");
                    return false;
                }
  */

import org.opencv.core.*;
import org.opencv.core.Point;

import org.opencv.highgui.HighGui;
import org.opencv.imgcodecs.Imgcodecs;
import org.opencv.imgproc.Imgproc;
import org.opencv.imgproc.Moments;

import static org.opencv.core.Core.FILLED;
import static org.opencv.core.Core.calcCovarMatrix;
import static org.opencv.core.CvType.CV_8UC3;
import static org.opencv.highgui.HighGui.createJFrame;
import static org.opencv.highgui.HighGui.imshow;
import static org.opencv.imgcodecs.Imgcodecs.imread;
import static org.opencv.imgcodecs.Imgcodecs.imwrite;

import java.io.File;
import java.lang.reflect.Array;
import java.util.ArrayList;

//REFERENCES:
//https://docs.opencv.org/3.4.3/d9/db0/tutorial_hough_lines.
//https://stackoverflow.com/questions/43443309/count-red-pixel-in-a-given-image
//https://www.wikihow.com/Calculate-Percentage-in-Java
//https://riptutorial.com/opencv/example/21963/converting-an-mat-object-to-an-bufferedimage-object
//https://beginnersbook.com/2013/12/java-arraylist-of-object-sort-example-comparable-and-comparator/
//https://www.programiz.com/java-programming/examples/standard-deviation
//https://www.geeksforgeeks.org/how-to-remove-duplicates-from-arraylist-in-java/
//https://stackoverflow.com/questions/7988486/how-do-you-calculate-the-variance-median-and-standard-deviation-in-c-or-java/7988556
//https://stackoverflow.com/questions/10396970/sort-a-list-that-contains-a-custom-class
//https://stackoverflow.com/questions/37946482/crop-images-area-with-opencv-java
//https://docs.opencv.org/3.4/dd/dd7/tutorial_morph_lines_detection.html
//https://docs.opencv.org/3.4/d0/d49/tutorial_moments.html
//https://docs.opencv.org/2.4/doc/tutorials/imgproc/shapedescriptors/moments/moments.html
//https://docs.opencv.org/3.3.1/d3/dc0/group__imgproc__shape.html#ga17ed9f5d79ae97bd4c7cf18403e1689a
//http://androiderstuffs.blogspot.com/2016/06/detecting-rectangle-using-opencv-java.html
//https://stackoverflow.com/questions/23327502/opencv-how-to-draw-minarearect-in-java
//https://stackoverflow.com/questions/30056910/opencv-java-modify-pixel-values
//https://stackoverflow.com/questions/18345969/how-to-get-the-mass-center-of-a-contour-android-opencv
//https://docs.opencv.org/3.0-beta/doc/py_tutorials/py_feature2d/py_features_harris/py_features_harris.html


//GOAL for 21st


//Classifier 01
//Have args so can call "java image-identification-classifier01 XX XX"
//args can be parameters in algorthim such as threshold or theta?
//Run on 5000 images.
//Record success rates
//All done with makefile


//But first understand houghline transform
//Know what the algorithm being used is doing.
//MAke constants for this classifier
//Make java be able to run on CMD line

public class MainMorph {
    static public class Pair{
        //Privates
        private Boolean _b;
        private Integer _i;

        //Constructor
        public Pair(Boolean b, Integer i){
            _b = b;
            _i = i;
        }
        public  Pair(){
            _b = null;
            _i = null;
        }

        //Getters
        public Boolean getBoolean() {return _b;}
        public Integer getInteger() {return _i;}

        //Setters
        public void setBoolean (Boolean b){_b = b;}
        public void setInteger (Integer i){_i = i;}

        //ToString
        public String toString() {return  "Boolean: " + _b + " Integer: " + _i;}
    }

    //CODE VERSIONS
    static int CODE_VERSION  = 9;
    static int IMAGE_VERSION = 3;
    //GLOBAL_CONSTANTS

    static double THRESHOLD_C    = 4;
    static double THRESHOLD_AREA_SIZE  = 10000;
    static double THRESHOLD_AREA_COUNT = 10;

    //

    private static void imageViewer(String winName, Mat img) {
        try {
            //Internal display - Overview - Will Distort High Res images
            if(IMAGE_VERSION == 1) {
                HighGui.namedWindow(winName, HighGui.WINDOW_NORMAL);
                HighGui.resizeWindow(winName, 1000, 1000);
                imshow(winName, img);

                HighGui.moveWindow(winName, 500, 0);
                HighGui.waitKey(0);

                HighGui.destroyWindow(winName);
            }
            //Internal display - Segmented - Will _NOT_ Distort High Res images
            if(IMAGE_VERSION == 2) {
                HighGui.namedWindow(winName, HighGui.WINDOW_AUTOSIZE);
                HighGui.resizeWindow(winName, 1000, 1000);
                imshow(winName, img);
                HighGui.moveWindow(winName, 500, 0);
                HighGui.waitKey(0);

                HighGui.destroyWindow(winName);
            }
            //External display - Save Images for manual viewing
            if(IMAGE_VERSION == 3) {
                //save file (testing purposes)
                imwrite(winName+".jpg", img);
            }
        }
        catch (Exception e){
            e.printStackTrace();
        }
    }

    //MAIN
    public static void main(String[] args) {
        System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
        try {
            //Variables
            System.out.println("Running Code version: " + CODE_VERSION + " Image Version: " +IMAGE_VERSION);
            Mat edgesDetectedRGB = new Mat();
            Mat clustersFoundRGB = new Mat();

            String testDirectory = "/Scratch/cpb16/is-sheet-music-encore/image-identification-dev-02/image-identification-development/";
            String directory = "/Scratch/cpb16/is-sheet-music-encore/download-images/MU/";
            String hiresDirectory = "/Scratch/cpb16/is-sheet-music-encore/hires-download-images/";

            //!!!!!!!!!!!!!!!!!!!!!!!!!!!NOT!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            //mdp.39015097852365-2.png 176 lines    Contents page.
            //mdp.39015097852555-3.png 76  lines
            //!!!!!!!!!!!!!!!!!!!!!!!!!!!NOTNOT!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            //coo.31924062612282-9.png 8   lines
            //String default_file =testDirectory+"TestImages/NotNot/mdp.39015080972303-3.png"; //WHY GREY? DUE TO IMAGE LARGE, ZOOM IN
            //String default_file =hiresDirectory+"BK/NotSheetMusic/aeu.ark+=13960=t2q53nq6w-6.png";
            //String default_file =hiresDirectory+"BK/NotSheetMusic/aeu.ark+=13960=t9z03w65z-4.png";
            //String default_file =hiresDirectory+"BK/NotSheetMusic/loc.ark+=13960=t50g4443d-5.png";
            //String default_file =hiresDirectory+"MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-1.png";
            //String default_file =hiresDirectory+"MU/SheetMusic/emu.010001066823-9.png";
            //String default_file =hiresDirectory+"MU/SheetMusic/bc.ark+=13960=t2j72dt1p-10.png";
            //String default_file =hiresDirectory+"MU/SheetMusic/bc.ark+=13960=t2j72dt1p-7.png";
            //String default_file =hiresDirectory+"MU/SheetMusic/coo.31924062612282-9.png";
            //String default_file =hiresDirectory+"MU/NotSheetMusic/mdp.39015096363935-1.png";
            //String default_file =hiresDirectory+"MU/SheetMusic/coo.31924062612282-9.png";
            //String default_file = "/Scratch/cpb16/is-sheet-music-encore/image-identification-terminal/TestImages/hi-res-test-coo.31924062612282-9.png";

            //String default_file = hiresDirectory+"/BK/NotSheetMusic/aeu.ark+=13960=t2s47k537-4.png"; //centre example
            //String default_file = hiresDirectory+"/BK/NotSheetMusic/aeu.ark+=13960=t3tt4xf2t-2.png"; //cross
            //TestNew images used
            //String default_file = hiresDirectory+"/MU/SheetMusic/aeu.ark+=13960=t93787r1w-10.png";    //Bleed
            //String default_file = hiresDirectory+"/MU/SheetMusic/bc.ark+=13960=t2j72dt1p-10.png";     //Handwritten
            //String default_file = hiresDirectory+"/MU/SheetMusic/bc.ark+=13960=t2j72dt1p-7.png";      //Handwritten 3072 4176
            //String default_file = hiresDirectory+"/MU/SheetMusic/bc.ark+=13960=t2j72dt1p-8.png";      //Handwritten
            //String default_file = hiresDirectory+"/MU/SheetMusic/bc.ark+=13960=t2j72dt1p-9.png";      //Handwritten
            //String default_file = hiresDirectory+"/MU/SheetMusic/coo.31924062612282-9.png";           //Snippet
            //String default_file = hiresDirectory+"/MU/SheetMusic/dul1.ark+=13960=t2x41569k-10.png";   //Generated
            //String default_file = hiresDirectory+"/MU/SheetMusic/dul1.ark+=13960=t2x41569k-7.png";
            //String default_file = hiresDirectory+"/MU/SheetMusic/dul1.ark+=13960=t2x41569k-8.png";
            //String default_file = hiresDirectory+"/MU/SheetMusic/dul1.ark+=13960=t2x41569k-9.png";
            //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-10.png"; //contentpage
            //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-1.png";  //Image evaluation
            //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-2.png";  //large numbers
            //String default_file = hiresDirectory+ "MU/SheetMusic/mdp.39015096400919-9.png";
            //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-3.png";
            //String default_file = hiresDirectory+"/MU/SheetMusic/mdp.39015080921409-9.png";
            //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-4.png";
            //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-5.png";
            //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-6.png";
            //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-7.png";
            //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-8.png";
            //String default_file = hiresDirectory+"/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-9.png";
            String default_file = hiresDirectory+"/MU/SheetMusic/mdp.39015096398899-4.png";



            //String default_file = testDirectory+"TestImages/MorphTester.png";
            //String default_file = testDirectory+"TestImages/NotSheetMusic01.png";
            //String default_file = testDirectory+"TestImages/NotSheetMusic02.png";
            //String default_file = testDirectory+"TestImages/SheetMusic01.png";
            //String default_file = testDirectory+"TestImages/SheetMusic02.png";
            //String default_file = testDirectory+"TestImages/vLine.png";
            String filename = ((args.length > 0) ? args[0] : default_file);
            File file = new File(filename);
            if(!file.exists()){System.err.println("Image not found: "+ filename);}

            int horizontalLineCount =0;

            // Load an image
            Mat original = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
            System.out.println("Width: " + original.width() + " Height: " + original.height());
            Mat binarized = original.clone();
            
            //Imgproc.adaptiveThreshold(original, binarized,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
            //TEST PARAMETERSImgproc.adaptiveThreshold(original, edgesDetected,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 531,1);
            //Imgproc.threshold(original,original, 127, 255, Imgproc.THRESH_BINARY);
            //************************
            //Argument Setup
            //************************
            int tempvariable = 0;
            if (tempvariable ==1){
                Imgproc.adaptiveThreshold(original, binarized, 255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C, Imgproc.THRESH_BINARY_INV, 1001, 5);
            }
            else {

                int borderIgnoreAmount = 0;
                double divisor;
                switch (borderIgnoreAmount) {
                    case 5:
                        divisor = 40;
                        break;
                    case 10:
                        divisor = 20;
                        break;
                    case 20:
                        divisor = 10;
                        break;
                    case 40:
                        divisor = 5;
                        break;
                    case 0:
                        divisor = -1;
                        break;
                    default:
                        divisor = -1;
                }
                if (divisor != -1) {
                    Mat mid = new Mat();
                    Imgproc.adaptiveThreshold(original, mid, 255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C, Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
                    double maxX = mid.size().width;
                    double maxY = mid.size().height;
                    Point cp1 = new Point(maxX / divisor, maxY / divisor);
                    Point cp2 = new Point(maxX - cp1.x, maxY - cp1.y);
                    Rect rectCrop = new Rect(cp1, cp2);
                    binarized = mid.submat(rectCrop);
                } else {
                    Imgproc.adaptiveThreshold(original, binarized, 255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C, Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
                }

                System.out.println("Width: " + binarized.width() + " Height: " + binarized.height());
            }

            //****************MORPHOLOGY****************************************************************************************
            //ADDIOTIONAL FILTERING TO STOP STREAKS
            //LOOK INTO STREAKS MORPHOGOLY.
            //****************MORPHOLOGY****************************************************************************************

            // Create the images that will use to extract the horizontal and vertical lines

            //dynamic morphology??
            if(CODE_VERSION == 1) {
                int hori = binarized.width();
                int vert = binarized.height();
                //Find ratio between 100 and width and 100 and height
                int divX = hori/10;
                int divY = vert/10;
                int sizeX = (hori/divX) * 10;
                int sizeY = (vert/divY) * 10;

                Mat test = binarized.clone();
                imageViewer("Original", test);

                System.out.println("hori: " + hori + '\t' + "vert: " + vert);
                System.out.println("sizeX: " + sizeX + '\t' + "sizeY: " + sizeY);

                Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(sizeX, (sizeY/100)));
                Imgproc.erode(test,test,kernelErode);
                imageViewer("01 Erode", test);

                Mat kernelDialate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(sizeX,(sizeY/10)));
                Imgproc.dilate(test, test, kernelDialate);
                imageViewer("02 Dialate", test);

                Mat kernelErodeAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size((sizeX/10),(sizeY/5)));
                Imgproc.erode(test,test,kernelErodeAgain);
                imageViewer(" 03 Erode Again", test);

                Mat kernelClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size((sizeX/10)*3,(sizeY/10)*3));
                Imgproc.morphologyEx(test,test,Imgproc.MORPH_CLOSE, kernelClose);
                imageViewer("04 Close", test);

                Imgproc.adaptiveThreshold(test, test,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
                imageViewer("05 Binarized", test);

                Mat kernelOpen = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size((sizeX/10),(sizeY/20)));
                Imgproc.morphologyEx(test,test,Imgproc.MORPH_OPEN, kernelOpen);
                imageViewer(" 06 Open", test);

                Mat kernelDialateAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size((sizeX/5),(sizeY/100)));
                Imgproc.dilate(test, test, kernelDialateAgain);
                imageViewer("07 Dialate", test);


                Mat kernelCloseAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size((sizeX/10),(sizeY/2)));
                Imgproc.morphologyEx(test,test,Imgproc.MORPH_CLOSE, kernelCloseAgain);
                imageViewer(" 08 Close Again (Final)", test);
            }
            //Successful hardcode for morhpology
            if (CODE_VERSION == 2) {

                //MAKE SURE BLACK & WHITE
                Mat test = binarized.clone();
                imageViewer("00 Binarized Original", test);

                Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(100,1));
                Imgproc.erode(test,test,kernelErode);
                imageViewer("01 Erode", test);

                Mat kernelDialate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(110,10));
                Imgproc.dilate(test, test, kernelDialate);
                imageViewer("02 Dialate", test);

                Mat kernelErodeAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,20));
                Imgproc.erode(test,test,kernelErodeAgain);
                imageViewer(" 03 Erode Again", test);

                Mat kernelClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(35,20));
                Imgproc.morphologyEx(test,test,Imgproc.MORPH_CLOSE, kernelClose);
                imageViewer("04 Close", test);

                Imgproc.threshold(test,test, 127, 255, Imgproc.THRESH_BINARY);
                imageViewer("05 Binarized", test);

                Mat kernelOpen = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(4,4));
                Imgproc.morphologyEx(test,test,Imgproc.MORPH_OPEN, kernelOpen);
                imageViewer(" 06 Open", test);

                Mat kernelDialateAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(1,10));
                Imgproc.dilate(test, test, kernelDialateAgain);
                imageViewer("07 Dialate", test);

                Mat kernelCloseAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,50));
                Imgproc.morphologyEx(test,test,Imgproc.MORPH_CLOSE, kernelCloseAgain);
                imageViewer(" 08 Close Again (Final)", test);

                //FIGURE OUT FLOOD FILL!!
                //Imgproc.floodFill(test,test, new Point(1,1), new Scalar(2));

            }
            //Tutorial/Demo Code
            if (CODE_VERSION == 3) {
                Mat horizontal = binarized.clone();
                Mat vertical = binarized.clone();
                // Specify size on horizontal axis
                int horizontal_size = horizontal.cols() / 50;
                // Create structure element for extracting horizontal lines through morphology operations
                Mat horizontalStructure = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(horizontal_size, 2));
                // Apply morphology operations
                Imgproc.erode(horizontal, horizontal, horizontalStructure);
                Imgproc.dilate(horizontal, horizontal, horizontalStructure);
                // Show extracted horizontal lines
                imageViewer("horizontal", horizontal);
                // Specify size on vertical axis
                int vertical_size = vertical.rows() / 30;
                // Create structure element for extracting vertical lines through morphology operations
                Mat verticalStructure = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(1, vertical_size));
                // Apply morphology operations
                Imgproc.erode(vertical, vertical, verticalStructure);
                Imgproc.dilate(vertical, vertical, verticalStructure);
                // Show extracted vertical lines
                imageViewer("vertical", vertical);
                // Inverse vertical image
                Core.bitwise_not(vertical, vertical);
                imageViewer("vertical_bit", vertical);
                // Extract edges and smooth image according to the logic
                // 1. extract edges
                // 2. dilate(edges)
                // 3. src.copyTo(smooth)
                // 4. blur smooth img
                // 5. smooth.copyTo(src, edges)
                // Step 1
                Mat edges = new Mat();
                Imgproc.adaptiveThreshold(vertical, edges, 255, Imgproc.ADAPTIVE_THRESH_MEAN_C, Imgproc.THRESH_BINARY, 3, -2);
                imageViewer("edges", edges);
                // Step 2
                Mat kernel = Mat.ones(2, 2, CvType.CV_8UC1);
                Imgproc.dilate(edges, edges, kernel);
                imageViewer("dilate", edges);
                // Step 3
                Mat smooth = new Mat();
                vertical.copyTo(smooth);
                // Step 4
                Imgproc.blur(smooth, smooth, new Size(2, 2));
                // Step 5
                smooth.copyTo(vertical, edges);
                // Show final result
                imageViewer("smooth - final", vertical);
                System.exit(0);
            }
            //Better morphology attempt - static
            if(CODE_VERSION == 4) {

                //Display Original
                imageViewer("original", original);

                Mat test = binarized.clone();
                Mat pre = binarized.clone();
                Mat dst = new Mat();

                imageViewer("00 Inverse Binarized Original", test);

                //remove large items of no interest pre proc
                //denoize
                //heal
                //fnd large images, write to a seperate mat.
                //draw these onto orignal image(binerized) in red
                //turn all red pixels in image to black


                //denoize
                Mat denoize = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(3,3));
                Imgproc.morphologyEx(pre,pre, Imgproc.MORPH_OPEN, denoize);
                imageViewer("Denoize - PRE", pre);

                //close up gaps
                Mat gapCloser = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(5,5));
                Imgproc.morphologyEx(pre,pre,Imgproc.MORPH_CLOSE, gapCloser);
                imageViewer("gap closer - PRE", pre);

                Mat kernelHighlightLarge = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10, 10));
                Imgproc.erode(pre,pre, kernelHighlightLarge);
                imageViewer("Highlight Large - PRE", pre);

                //change white pixels to red
                ArrayList<MatOfPoint> contoursPre = new ArrayList<MatOfPoint>();
                Mat hierarchyPre = new Mat();

                //PARAMETERS: input image, output array of arrays, output array, contour retrieval mode, contour approximation method.
                //(contours)  output array of arrays: Detected contours. Each contour is stored as a vector of points
                //(hierarchy) output array:           Optional output vector, containing information about the image topology.
                //https://docs.opencv.org/3.3.1/d3/dc0/group__imgproc__shape.html#ga17ed9f5d79ae97bd4c7cf18403e1689a

                Imgproc.findContours(pre, contoursPre, hierarchyPre, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);

                //Draw contours and record areas

                Mat drawingPre = Mat.zeros(test.size(), CvType.CV_8UC3);
                Mat mask = new Mat(drawingPre.size(), CV_8UC3,new Scalar(0));
                Scalar colorPre = new Scalar(255, 255, 255);
                Imgproc.drawContours(mask, contoursPre, -1, new Scalar(255, 255, 255), FILLED);
                Imgproc.fillPoly(drawingPre, contoursPre,colorPre);
                imageViewer("DRAWINGPRE", drawingPre);


                //FIIIIIIIIIIIIIIIIIIIIIIIIIIXXXXXXXXXXXX
                //Remove from main Mat
                Core.bitwise_not(mask,mask);
                imageViewer("MASK", mask);
                imageViewer("TEST", test);

                drawingPre.copyTo(test, mask);
                imageViewer("COMBINE", test);

                //start staff line detection

                Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,1));
                Imgproc.erode(test,test,kernelErode);
                imageViewer("01 Erode plus pre", test);

                Mat kernelDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(20,3));
                Imgproc.dilate(test,test,kernelDilate);
                imageViewer("02 Dilate", test);

                Mat kernelOpening = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(4,4));
                Imgproc.morphologyEx(test, test, Imgproc.MORPH_CLOSE, kernelOpening);
                imageViewer("03 Open", test);

                Mat kernelErode02 = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(8,8));
                Imgproc.erode(test,test,kernelErode02);
                imageViewer("04 Erode (Final)", test);


                //DETECT OUTLINE AND FIND AREA OF THESE LINES.
                ArrayList<MatOfPoint> contours = new ArrayList<MatOfPoint>();
                Mat hierarchy = new Mat();

                //PARAMETERS: input image, output array of arrays, output array, contour retrieval mode, contour approximation method.
                //(contours)  output array of arrays: Detected contours. Each contour is stored as a vector of points
                //(hierarchy) output array:           Optional output vector, containing information about the image topology.
                //https://docs.opencv.org/3.3.1/d3/dc0/group__imgproc__shape.html#ga17ed9f5d79ae97bd4c7cf18403e1689a

                Imgproc.findContours(test, contours, hierarchy, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);

                //Draw contours and record areas
                Mat drawing = Mat.zeros(test.size(), CvType.CV_8UC3);
                Mat drawing2 = Mat.zeros(test.size(), CvType.CV_8UC3);
                int areaCounter = 0;
                for (int i = 0; i < contours.size(); i++) {
                    double area = Imgproc.contourArea(contours.get(i));
                    if(area > THRESHOLD_AREA_SIZE ) {
                        areaCounter++;
                        Scalar color = new Scalar(0, 0, 255);
                        Imgproc.drawContours(drawing, contours, i, color, 1);
                        System.out.println("AREA: " + area);
                    }
                }

                //Classifier Calculation
                if(areaCounter >= THRESHOLD_AREA_COUNT){
                    System.out.println("THIS IS SHEET MUSIC");
                    System.out.println(areaCounter);
                }


                //Show in a window
                imageViewer("Contours", drawing);
            }
            //Better morphology attempt - dynamic
            if(CODE_VERSION == 5) {
                int hori = binarized.width();
                int vert = binarized.height();
                //Find ratio between 100 and width and 100 and height
                int sizeX100 = 10 * (hori/68);
                int sizeY100 = 10 * (vert/46);
                int sizeX10 = (hori/68);
                int sizeY10 = (vert/46);
                int sizeX1 = (hori/68)/10;
                int sizeY1 = (vert/46)/10;

                //SizeX should always be a 68th * 10. Based off the defualt tester image "coo.*"
                //SizeT should always be a 46th * 10

                System.out.println(hori + " " + vert + " "  + sizeX1 + " " + sizeY1);
                //Display Original
                imageViewer("original", original);

                Mat test = binarized.clone();
                imageViewer("00 Inverse Binarized Original", test);

                //Remove very large and wide black spaces (8th of the page)
                //Mat kernelRemoveLarge = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(hori/8, vert/8));
                //Imgproc.erode(test,test, kernelRemoveLarge);
                //imageViewer("Remove Large", test);

                //Eliminate things that are not long and thin
                Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(sizeX10,sizeY1)); //new Size(10,1));
                Imgproc.erode(test,test,kernelErode);
                imageViewer("01 Erode", test);

                Mat kernelDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(sizeX10*2,sizeY1*3)); //new Size(20,3));
                Imgproc.dilate(test,test,kernelDilate);
                imageViewer("02 Dilate", test);

                Mat kernelClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(sizeX1*4,sizeY1*4)); //new Size(4,4));
                Imgproc.morphologyEx(test, test, Imgproc.MORPH_CLOSE, kernelClose);
                imageViewer("03 Open", test);

                Mat kernelErode02 = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(sizeX1*8,sizeX1*8)); //new Size(8,8));
                Imgproc.erode(test,test,kernelErode02);
                imageViewer("04 Erode (Final)", test);


                //DETECT OUTLINE AND FIND AREA OF THESE LINES.
                ArrayList<MatOfPoint> contours = new ArrayList<MatOfPoint>();
                Mat hierarchy = new Mat();

                //PARAMETERS: input image, output array of arrays, output array, contour retrieval mode, contour approximation method.
                //(contours)  output array of arrays: Detected contours. Each contour is stored as a vector of points
                //(hierarchy) output array:           Optional output vector, containing information about the image topology.
                //https://docs.opencv.org/3.3.1/d3/dc0/group__imgproc__shape.html#ga17ed9f5d79ae97bd4c7cf18403e1689a

                Imgproc.findContours(test, contours, hierarchy, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);

                //Draw contours and record areas
                Mat drawing = Mat.zeros(test.size(), CvType.CV_8UC3);
                int areaCounter = 0;
                for (int i = 0; i < contours.size(); i++) {
                    double area = Imgproc.contourArea(contours.get(i));
                    if(area > THRESHOLD_AREA_SIZE ) {
                        areaCounter++;
                        Scalar color = new Scalar(0, 0, 255);
                        Imgproc.drawContours(drawing, contours, i, color, 1);
                        System.out.println("AREA: " + area);
                    }
                }

                //Classifier Calculation
                if(areaCounter >= THRESHOLD_AREA_COUNT){
                    System.out.println("THIS IS SHEET MUSIC");
                    System.out.println(areaCounter);
                }


                //Show in a window
                imageViewer("Contours", drawing);
            }
            //MASK UNDERSTANDING
            if(CODE_VERSION == 6) {
                String path ="/Scratch/cpb16/is-sheet-music-encore/hires-download-images/MU/NotSheetMusic/aeu.ark+=13960=t0dv28v9r-1.png";
                Mat mask = new Mat();
                Mat dst = new Mat();
                //Get source image and binerize
                Mat src = Imgcodecs.imread(path, Imgcodecs.IMREAD_GRAYSCALE);
                Imgproc.adaptiveThreshold(original, src,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
                imageViewer("src", src);

                //Find unwanted material, then invert it so mask removes not keeps.
                Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(100,1));
                Imgproc.erode(src,mask,kernelErode);
                Mat kernelDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(110,10));
                Imgproc.dilate(mask, mask, kernelDilate);
                Core.bitwise_not(mask,mask);
                imageViewer("mask", mask);

                //Copy source image to new Mat, with mask in use
                src.copyTo(dst, mask);
                imageViewer("dst", dst);




            }
            //Mask implementation
            if(CODE_VERSION == 7) {

                //Display Original
                imageViewer("original", original);

                Mat src = binarized.clone();
                Mat test = binarized.clone();
                Mat mask = new Mat();
                Mat dst = new Mat();

                imageViewer("00 Inverse Binarized Original", src);

                //denoize
                Mat denoize = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(3,3));
                Imgproc.morphologyEx(src,mask, Imgproc.MORPH_OPEN, denoize);
                imageViewer("01 Denoize - mask", mask);

                //close up gaps
                Mat gapCloser = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(5,5));
                Imgproc.morphologyEx(mask,mask,Imgproc.MORPH_CLOSE, gapCloser);
                imageViewer("02 gap closer - mask", mask);

                //Isolate large items
                Mat isolateLarge = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(8, 8));
                Imgproc.morphologyEx(mask,mask,Imgproc.MORPH_OPEN, isolateLarge);
                imageViewer("03 Isolate Large - mask", mask);
                Core.bitwise_not(mask,mask);

                //Remove unwanted large items from image
                src.copyTo(dst, mask);
                imageViewer("04 Large Items Removed", dst);

                //start staff line detection

                Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,1));
                Imgproc.erode(dst,test,kernelErode);
                imageViewer("11 Erode plus pre", test);

                Mat kernelDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(20,3));
                Imgproc.dilate(test,test,kernelDilate);
                imageViewer("12 Dilate", test);

                Mat kernelOpening = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(4,4));
                Imgproc.morphologyEx(test, test, Imgproc.MORPH_CLOSE, kernelOpening);
                imageViewer("13 Open", test);

                Mat kernelErode02 = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(8,8));
                Imgproc.erode(test,test,kernelErode02);
                imageViewer("14 Erode (Final)", test);


                //DETECT OUTLINE AND FIND AREA OF THESE LINES.
                ArrayList<MatOfPoint> contours = new ArrayList<MatOfPoint>();
                Mat hierarchy = new Mat();

                //PARAMETERS: input image, output array of arrays, output array, contour retrieval mode, contour approximation method.
                //(contours)  output array of arrays: Detected contours. Each contour is stored as a vector of points
                //(hierarchy) output array:           Optional output vector, containing information about the image topology.
                //https://docs.opencv.org/3.3.1/d3/dc0/group__imgproc__shape.html#ga17ed9f5d79ae97bd4c7cf18403e1689a

                Imgproc.findContours(test, contours, hierarchy, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);

                //Draw contours and record areas
                Mat drawing = Mat.zeros(test.size(), CvType.CV_8UC3);
                int areaCounter = 0;


                Imgproc.drawContours(drawing, contours, -1, new Scalar(0, 255, 0), FILLED);
//                for (int i = 0; i < contours.size(); i++) {
//                    Scalar color = new Scalar(0, i, i);
//                    double area = Imgproc.contourArea(contours.get(i));
//                    Imgproc.drawContours(drawing, contours, i, color, FILLED);
//                    System.out.println("AREA: " + area);
//
//                }
                imageViewer("Contours found", drawing);

                //Classifier Calculation
                if(areaCounter >= THRESHOLD_AREA_COUNT){
                    System.out.println("THIS IS SHEET MUSIC");
                    System.out.println(areaCounter);
                }


            }
            //Mask implementations (LARGE AND SMALL) - HIGH RES NUMBER MOD
            if(CODE_VERSION == 8) {

                //Display Original
                imageViewer("original", original);

                Mat test = binarized.clone();


                imageViewer("00 Inverse Binarized Original", test);


                //************************************
                //Large Object Removal
                //************************************
                Mat srcLOR = binarized.clone();
                Mat maskLOR = new Mat();
                Mat dstLOR = new Mat();

                //denoize
                Mat denoize = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(5,5));
                Imgproc.morphologyEx(srcLOR,maskLOR, Imgproc.MORPH_OPEN, denoize);
                imageViewer("01 Denoize - mask", maskLOR);

                //close up gaps
                Mat gapCloser = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(5,5));
                Imgproc.morphologyEx(maskLOR,maskLOR,Imgproc.MORPH_CLOSE, gapCloser);
                imageViewer("02 gap closer - mask", maskLOR);

                //Isolate large items
                Mat isolateLarge = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(8, 8));
                Imgproc.morphologyEx(maskLOR,maskLOR,Imgproc.MORPH_OPEN, isolateLarge);
                imageViewer("03 Isolate Large - mask", maskLOR);

                //Remove large items from image
                Core.bitwise_not(maskLOR,maskLOR);
                srcLOR.copyTo(dstLOR, maskLOR);
                imageViewer("04 Large Items Removed", dstLOR);

                //****************************************
                //Small object removal (SOR)
                //****************************************

                Mat srcSOR = dstLOR.clone();
                Mat maskSOR = new Mat();
                Mat dstSOR = new Mat();

                Mat startSOR =Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(7,7));
                Imgproc.morphologyEx(srcSOR,maskSOR, Imgproc.MORPH_OPEN, startSOR);
                imageViewer("11 show small - mask", maskSOR);

                Mat highlightSmall = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(7,7));
                Imgproc.dilate(maskSOR, maskSOR, highlightSmall);
                imageViewer("12 highlight small - mask", maskSOR);

/*              Mat isolateSmall =Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,10));
                Imgproc.morphologyEx(maskSOR,maskSOR,Imgproc.MORPH_CLOSE, isolateSmall);
                imageViewer("13 isolate small - mask", maskSOR);
*/

                //Remove small items from image
                Core.bitwise_not(maskSOR, maskSOR);
                srcSOR.copyTo(dstSOR, maskSOR);
                imageViewer("14 Small Items Removed", dstSOR);


                //****************************************
                //start staff line detection
                //****************************************

                Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(15,2)); //10,2
                Imgproc.erode(dstSOR,test,kernelErode);
                imageViewer("21 Erode plus pre", test);

                Mat kernelDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //20,3
                Imgproc.dilate(test,test,kernelDilate);
                imageViewer("22 Dilate", test);

                Mat kernelClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //4,4
                Imgproc.morphologyEx(test, test, Imgproc.MORPH_CLOSE, kernelClose);
                imageViewer("23 Close", test);


                Mat kernelErode02 = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //10,1
                Imgproc.erode(test,test,kernelErode02);
                imageViewer("24 Erode (Final)", test);

                //********************************************************************************
                //DETECT OUTLINE AND FIND AREA OF THESE LINES.
                //********************************************************************************
                ArrayList<MatOfPoint> contours = new ArrayList<MatOfPoint>();
                ArrayList<MatOfPoint> largeContours = new ArrayList<MatOfPoint>();
                ArrayList<MatOfPoint> postContours = new ArrayList<MatOfPoint>();
                Mat hierarchy = new Mat();

                //PARAMETERS: input image, output array of arrays, output array, contour retrieval mode, contour approximation method.
                //(contours)  output array of arrays: Detected contours. Each contour is stored as a vector of points
                //(hierarchy) output array:           Optional output vector, containing information about the image topology.
                //https://docs.opencv.org/3.3.1/d3/dc0/group__imgproc__shape.html#ga17ed9f5d79ae97bd4c7cf18403e1689a

                Imgproc.findContours(test, contours, hierarchy, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);

                System.out.println(contours.size());
                //Draw contours and record areas
                Mat allContoursFound = Mat.zeros(test.size(), CvType.CV_8UC3);
                Mat largeContoursFound = allContoursFound.clone() ;
                Mat postContoursFound = allContoursFound.clone();
                int areaCounter = 0;

                //Have created a preprocess to remove large objects.
                //Need to now finalized Classifier, re try area detection.
                //Paths to take - rectangle boxes around detected contours over threshold (area or perimeter)
                //Just use area and periemter to determine if sheet music
                //Discuss with david before weekend perhaps?

                Imgproc.drawContours(allContoursFound, contours, -1, new Scalar(0, 255, 0), 1); //USES LINE_8
                for (int i = 0; i < contours.size(); i++) {
                    double area = Imgproc.contourArea(contours.get(i));
                    if(area > 100) {
                        System.out.println("AREA: " + area);
                        Imgproc.drawContours(largeContoursFound, contours, i, new Scalar(255, 0, 0), FILLED);
                        //create list of large coutours found
                        largeContours.add(contours.get(i));
                    }
                }
                imageViewer("80 All Contours found", allContoursFound);
                imageViewer("81 Large Contours Found", largeContoursFound);

                //*****************************************************************
                //Circles on processed images
                //*****************************************************************
//                //Init arrays
//                Mat circleOutput = allContoursFound.clone();
//                MatOfPoint2f[] contoursPoly  = new MatOfPoint2f[largeContours.size()];
//                Rect[] boundRect = new Rect[largeContours.size()];
//                Point[] centers = new Point[largeContours.size()];
//                float[][] radius = new float[largeContours.size()][1];
//
//                //Fill arrays
//                for (int i = 0; i < largeContours.size(); i++) {
//                    contoursPoly[i] = new MatOfPoint2f();
//                    Imgproc.approxPolyDP(new MatOfPoint2f(largeContours.get(i).toArray()), contoursPoly[i], 1, true);
//                    boundRect[i] = Imgproc.boundingRect(new MatOfPoint(contoursPoly[i].toArray()));
//                    centers[i] = new Point();
//                    Imgproc.minEnclosingCircle(contoursPoly[i], centers[i], radius[i]);
//
//                }
//                //Draw circle for each large contour
//                for (int i = 0; i < largeContours.size(); i++) {
//                    Imgproc.rectangle(drawing, boundRect[i].tl(), boundRect[i].br(), color, 2);
//                    Imgproc.circle(circleOutput, centers[i], (int) radius[i][0],new Scalar(255, 0, 0), 1);
//                }
//                imageViewer("82 Circles found", circleOutput);

                //********************************************************************************
                //Centroids -Everything must be to scale
                //********************************************************************************

                ArrayList<Moments> mu = new ArrayList<Moments>(largeContours.size());
                Mat centreOutput = Mat.zeros(largeContoursFound.size(), CvType.CV_8UC3);
                for (int i = 0; i < largeContours.size(); i++) {
                    mu.add(i, Imgproc.moments(largeContours.get(i), false));
                    Moments p = mu.get(i);
                    int x = (int) (p.get_m10() / p.get_m00());
                    int y = (int) (p.get_m01() / p.get_m00());
                    Imgproc.circle(centreOutput, new Point(x, y), 4, new Scalar(255, 255, 255), 30);
                }
                imageViewer("83 Centres found", centreOutput);


                //***********************************************
                //PostProcessing - Morphology Classifier
                //  Use dilation to "Connect the dots"
                //  Testing showed the centroids were clustered together
                //  Then use area or perimeter as a classifier filter
                //REFINEREFINEREIFEN
                //REFINEREFINEREIFEN
                //REFINEREFINEREIFEN
                //REFINEREFINEREIFEN
                //REFINEREFINEREIFEN
                //REFINEREFINEREIFEN
                // FIX UP CLASSIFIER COMPARISON.
                // MORPHOLOGIES FUNCTIONS RETURN NULL AS THEIR RETURN VARIABLES. WHY?
                //REFINEREFINEREIFEN
                //REFINEREFINEREIFEN
                //REFINEREFINEREIFEN
                //REFINEREFINEREIFEN
                //REFINEREFINEREIFEN
                //***********************************************

                Mat postDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(150,15));
                Imgproc.dilate(centreOutput,centreOutput,postDilate);
                imageViewer("91 PostDilated", centreOutput);

                Mat postClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //4,4
                Imgproc.morphologyEx(centreOutput, centreOutput, Imgproc.MORPH_CLOSE, postClose);
                imageViewer("92 PostClose", centreOutput);

                Mat postDenoize = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(100,100));
                Imgproc.morphologyEx(centreOutput,centreOutput, Imgproc.MORPH_OPEN, postDenoize);
                imageViewer("93 PostDenoize", centreOutput);

                //Mat postOutline = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(50,50));
                //Imgproc.morphologyEx(centreOutput, centreOutput, Imgproc.MORPH_GRADIENT, postOutline);



                //Find area
                Mat centreOutputGrey = new Mat();
                Imgproc.cvtColor(centreOutput, centreOutputGrey, Imgproc.COLOR_RGB2GRAY);
                Imgproc.findContours(centreOutputGrey, postContours, hierarchy, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);

                for (int i = 0; i < postContours.size(); i++) {
                    double area = Imgproc.contourArea(postContours.get(i));
                    if(area > THRESHOLD_AREA_SIZE) {
                        System.out.println("POST AREA: " + area);
                        Imgproc.drawContours(postContoursFound, postContours, i, new Scalar(0, 255, 0), FILLED);
                        areaCounter++;
                    }
                }



                imageViewer("93 PostEND", postContoursFound);

                //Classifier Calculation
                if(areaCounter >= THRESHOLD_AREA_COUNT){
                    System.out.println("THIS IS SHEET MUSIC");
                    System.out.println(areaCounter);
                }


            }
            //ClassifierComparison - Using code version 8
            if(CODE_VERSION == 81) {

                System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
                Pair returnVariables = new Pair();
                int FILLED = -1;
                try{
                    //Mat original1 = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
                    //System.out.println("Width: " + original1.width() + " Height: " + original1.height());
                    //Mat original = original1.clone();
                    //Imgproc.adaptiveThreshold(original1, original,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);

                    Mat test = binarized.clone();
                    //************************************
                    //Large Object Removal
                    //************************************
                    Mat srcLOR = binarized.clone();
                    Mat maskLOR = new Mat();
                    Mat dstLOR = new Mat();

                    //denoize
                    Mat denoize = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(5,5));
                    Imgproc.morphologyEx(srcLOR,maskLOR, Imgproc.MORPH_OPEN, denoize);

                    //close up gaps
                    Mat gapCloser = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(5,5));
                    Imgproc.morphologyEx(maskLOR,maskLOR,Imgproc.MORPH_CLOSE, gapCloser);

                    //Isolate large items
                    Mat isolateLarge = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(8, 8));
                    Imgproc.morphologyEx(maskLOR,maskLOR,Imgproc.MORPH_OPEN, isolateLarge);

                    //Remove large items from image
                    Core.bitwise_not(maskLOR,maskLOR);
                    srcLOR.copyTo(dstLOR, maskLOR);

                    //****************************************
                    //Small object removal (SOR)
                    //****************************************

                    Mat srcSOR = dstLOR.clone();
                    Mat maskSOR = new Mat();
                    Mat dstSOR = new Mat();

                    Mat startSOR =Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(7,7));
                    Imgproc.morphologyEx(srcSOR,maskSOR, Imgproc.MORPH_OPEN, startSOR);

                    Mat highlightSmall = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(7,7));
                    Imgproc.dilate(maskSOR, maskSOR, highlightSmall);


/*              Mat isolateSmall =Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,10));
                Imgproc.morphologyEx(maskSOR,maskSOR,Imgproc.MORPH_CLOSE, isolateSmall);
                imageViewer("13 isolate small - mask", maskSOR);
*/

                    //Remove small items from image
                    Core.bitwise_not(maskSOR, maskSOR);
                    srcSOR.copyTo(dstSOR, maskSOR);


                    //****************************************
                    //start staff line detection
                    //****************************************

                    Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(15,2)); //10,2
                    Imgproc.erode(dstSOR,test,kernelErode);


                    Mat kernelDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //20,3
                    Imgproc.dilate(test,test,kernelDilate);


                    Mat kernelClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //4,4
                    Imgproc.morphologyEx(test, test, Imgproc.MORPH_CLOSE, kernelClose);



                    Mat kernelErode02 = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //10,1
                    Imgproc.erode(test,test,kernelErode02);


                    //********************************************************************************
                    //DETECT OUTLINE AND FIND AREA OF THESE LINES.
                    //********************************************************************************
                    ArrayList<MatOfPoint> contours = new ArrayList<MatOfPoint>();
                    ArrayList<MatOfPoint> largeContours = new ArrayList<MatOfPoint>();
                    ArrayList<MatOfPoint> postContours = new ArrayList<MatOfPoint>();
                    Mat hierarchy = new Mat();

                    //PARAMETERS: input image, output array of arrays, output array, contour retrieval mode, contour approximation method.
                    //(contours)  output array of arrays: Detected contours. Each contour is stored as a vector of points
                    //(hierarchy) output array:           Optional output vector, containing information about the image topology.
                    //https://docs.opencv.org/3.3.1/d3/dc0/group__imgproc__shape.html#ga17ed9f5d79ae97bd4c7cf18403e1689a

                    Imgproc.findContours(test, contours, hierarchy, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);

                    System.out.println(contours.size());
                    //Draw contours and record areas
                    Mat allContoursFound = Mat.zeros(test.size(), CvType.CV_8UC3);
                    Mat largeContoursFound = allContoursFound.clone() ;
                    Mat postContoursFound = allContoursFound.clone();
                    int areaCounter = 0;

                    //Have created a preprocess to remove large objects.
                    //Need to now finalized Classifier, re try area detection.
                    //Paths to take - rectangle boxes around detected contours over threshold (area or perimeter)
                    //Just use area and periemter to determine if sheet music
                    //Discuss with david before weekend perhaps?

                    Imgproc.drawContours(allContoursFound, contours, -1, new Scalar(0, 255, 0), 1); //USES LINE_8
                    for (int i = 0; i < contours.size(); i++) {
                        double area = Imgproc.contourArea(contours.get(i));
                        if(area > 100) {
                            //System.out.println("AREA: " + area);
                            Imgproc.drawContours(largeContoursFound, contours, i, new Scalar(255, 0, 0), FILLED);
                            //create list of large coutours found
                            largeContours.add(contours.get(i));
                        }
                    }

                    //*****************************************************************
                    //Circles and centres on processed images
                    //*****************************************************************

                    //Init arrays
                    Mat circleOutput = allContoursFound.clone();
                    MatOfPoint2f[] contoursPoly  = new MatOfPoint2f[largeContours.size()];
                    Point[] centers = new Point[largeContours.size()];
                    float[][] radius = new float[largeContours.size()][1];

                    //Fill arrays
                    for (int i = 0; i < largeContours.size(); i++) {
                        contoursPoly[i] = new MatOfPoint2f();
                        Imgproc.approxPolyDP(new MatOfPoint2f(largeContours.get(i).toArray()), contoursPoly[i], 1, true);
                        centers[i] = new Point();
                        Imgproc.minEnclosingCircle(contoursPoly[i], centers[i], radius[i]);

                    }
                    //Draw circle for each large contour
                    for (int i = 0; i < largeContours.size(); i++) {
                        Imgproc.circle(circleOutput, centers[i], (int) radius[i][0],new Scalar(255, 0, 0), 1);
                    }


                    //********************************************************************************
                    //Centroids - Everything must be to scale
                    //********************************************************************************

                    ArrayList<Moments> mu = new ArrayList<Moments>(largeContours.size());
                    Mat centreOutput = Mat.zeros(largeContoursFound.size(), CvType.CV_8UC3);
                    for (int i = 0; i < largeContours.size(); i++) {
                        mu.add(i, Imgproc.moments(largeContours.get(i), false));
                        Moments p = mu.get(i);
                        int x = (int) (p.get_m10() / p.get_m00());
                        int y = (int) (p.get_m01() / p.get_m00());
                        Imgproc.circle(centreOutput, new Point(x, y), 4, new Scalar(255, 255, 255), 30);
                    }

                    //***********************************************
                    //PostProcessing - Morphology Classifier
                    //  Use dilation to "Connect the dots"
                    //  Testing showed the centroids were clustered together
                    //  Then use area or perimeter as a classifier filter
                    //***********************************************

                    Mat postDilate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(150,15));
                    Imgproc.dilate(centreOutput,centreOutput,postDilate);

                    Mat postClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,4)); //4,4
                    Imgproc.morphologyEx(centreOutput, centreOutput, Imgproc.MORPH_CLOSE, postClose);

                    Mat postDenoize = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(100,100));
                    Imgproc.morphologyEx(centreOutput,centreOutput, Imgproc.MORPH_OPEN, postDenoize);

                    //Find area
                    Mat centreOutputGrey = new Mat();
                    Imgproc.cvtColor(centreOutput, centreOutputGrey, Imgproc.COLOR_RGB2GRAY);
                    Imgproc.findContours(centreOutputGrey, postContours, hierarchy, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);

                    for (int i = 0; i < postContours.size(); i++) {
                        double area = Imgproc.contourArea(postContours.get(i));
                        if(area > THRESHOLD_AREA_SIZE) {
                            //System.err.println("POST AREA: " + area);
                            Imgproc.drawContours(postContoursFound, postContours, i, new Scalar(0, 255, 0), FILLED);
                            areaCounter++;
                        }
                    }
                    //Classifier Calculation
                    if(areaCounter >= THRESHOLD_AREA_COUNT){
                        returnVariables.setBoolean(true);
                        returnVariables.setInteger(areaCounter);
                    }
                }
                catch(Exception e){
                    System.err.println(e);
                }
                //return returnVariables;
            }

            //Reset after david chat
            if(CODE_VERSION == 9){
                int areaCounter=0;
                //Display Original
                imageViewer("original", original);
                imageViewer("000 Inverse Binarized Original", binarized);


                //************************************
                //1. Large Object Remover
                //************************************
                Mat srcLOR = binarized.clone();
                Mat maskLOR = new Mat();
                Mat dstLOR = new Mat();

                //Remove small objects in prep for masking  (De-Noise)
                Mat removeSmallLOR = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(5,5));
                Imgproc.morphologyEx(srcLOR,maskLOR, Imgproc.MORPH_OPEN, removeSmallLOR);
                imageViewer("001 De-noise", maskLOR);

                //Heal the large items
                Mat healLOR = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(25,25)); //5,5
                Imgproc.morphologyEx(maskLOR,maskLOR, Imgproc.MORPH_CLOSE, healLOR);
                imageViewer("002 heal objects in mask", maskLOR);

                //IsolateLarge
                Mat isolateLargeLOR = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(30,30)); //8,8
                Imgproc.morphologyEx(maskLOR,maskLOR, Imgproc.MORPH_OPEN, isolateLargeLOR);
                imageViewer("003 Isolate large", maskLOR);

                Core.bitwise_not(maskLOR,maskLOR);
                srcLOR.copyTo(dstLOR, maskLOR);
                imageViewer("100 Large Items Removed", dstLOR);

                //                //CODE FROM PRESENTATION
//                Mat kernelErode = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(100,1));
//                Imgproc.erode(dstTOR,base,kernelErode);
//                imageViewer("201 Erode", base);
//
//                Mat kernelDialate = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(110,10));
//                Imgproc.dilate(base, base, kernelDialate);
//                imageViewer("202 Dialate", base);
//
//                Mat kernelErodeAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,20));
//                Imgproc.erode(base,base,kernelErodeAgain);
//                imageViewer(" 203 Erode Again", base);
//
//                Mat kernelClose = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(35,20));
//                Imgproc.morphologyEx(base,base,Imgproc.MORPH_CLOSE, kernelClose);
//                imageViewer("204 Close", base);
//
//                Imgproc.threshold(base,base, 127, 255, Imgproc.THRESH_BINARY);
//                imageViewer("205 Binarized", base);
//
//                Mat kernelOpen = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(4,4));
//                Imgproc.morphologyEx(base,base,Imgproc.MORPH_OPEN, kernelOpen);
//                imageViewer("206 Open", base);
//
//                Mat kernelDialateAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(1,10));
//                Imgproc.dilate(base, base, kernelDialateAgain);
//                imageViewer("207 Dialate", base);
//
//                Mat kernelCloseAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,50));
//                Imgproc.morphologyEx(base,base,Imgproc.MORPH_CLOSE, kernelCloseAgain);
//                imageViewer("208 Close Again (Final)", base);

                //***********************************
//                //3.1 Remove big outlines
//                //***********************************
//                Mat srcTOR = base.clone();
//                Mat maskTOR = new Mat();
//                Mat dstTOR = new Mat();
//
//                //Remove small objects in prep for masking (De-Noise)
//                Mat removeSmallTOR = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(5,5));
//                Imgproc.morphologyEx(srcTOR,maskTOR, Imgproc.MORPH_OPEN, removeSmallTOR);
//                imageViewer("2101 Remove Small from mask", maskTOR);
//
//                //heal the large items
//                Mat healTOR = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,10));
//                Imgproc.morphologyEx(maskTOR,maskTOR, Imgproc.MORPH_CLOSE, healTOR);
//                imageViewer("2102 heal objects in mask", maskTOR);
//
//                //Highlight black outline
//                Mat highlightLargeTOR = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(10,10));
//                Imgproc.erode(maskTOR,maskTOR,highlightLargeTOR);
//                imageViewer("2103 highlight objects", maskTOR);
//
//                Core.bitwise_not(maskTOR, maskTOR);
//                srcTOR.copyTo(dstTOR, maskTOR);
//                imageViewer("2200 Black outline Removed", dstTOR);







                //4. Classify like line clusters.
                Mat base = binarized.clone();
                //***********************************
                //3. Isolate straight lines
                //***********************************
                //Heal lines
                Mat healISL = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(86,1));
                Imgproc.morphologyEx(dstLOR,base, Imgproc.MORPH_OPEN, healISL);
                imageViewer("202 heal objects in mask", base);

                //Make White Blobs

                //NEED THIS??
                Mat kernelOpen = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(4,1));
                Imgproc.morphologyEx(base,base,Imgproc.MORPH_OPEN, kernelOpen);
                imageViewer("203 Open", base);
                //NEED THIS?

                Mat kernelDilateAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(1,10));
                Imgproc.dilate(base, base, kernelDilateAgain);
                imageViewer("204 Dilate", base);

                Mat kernelCloseAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(12,50));
                Imgproc.morphologyEx(base,base,Imgproc.MORPH_CLOSE, kernelCloseAgain);
                imageViewer("205 Close Again (Final)", base);

                //***********************************
                //4. Find 'Clusters'
                //   Need to find areas, using bounding boxes
                //   Find how tall the bounding box is, if its taller than 'x' then classify as Sheet Music
                //***********************************

                //*****************************************************************
                //4.1 Prep Rectangles on processed images
                //*****************************************************************
                ArrayList<MatOfPoint> contours = new ArrayList<MatOfPoint>();
                Mat hierarchy = new Mat();
                Imgproc.findContours(base, contours, hierarchy, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);
                //Draw contours and record areas
                Mat allContoursFound = Mat.zeros(base.size(), CvType.CV_8UC3);
                Mat rectOutput = allContoursFound.clone();
                Imgproc.drawContours(allContoursFound, contours, -1, new Scalar(0, 255, 0), 1); //USES LINE_8
                //Init arrays
                MatOfPoint2f[] contoursPoly  = new MatOfPoint2f[contours.size()];
                Rect[] boundRect = new Rect[contours.size()];

                //Fill arrays
                for (int i = 0; i < contours.size(); i++) {
                    contoursPoly[i] = new MatOfPoint2f();
                    Imgproc.approxPolyDP(new MatOfPoint2f(contours.get(i).toArray()), contoursPoly[i], 1, true);
                    boundRect[i] = Imgproc.boundingRect(new MatOfPoint(contoursPoly[i].toArray()));
                }
                //Draw circle for each large contour
                for (int i = 0; i < contours.size(); i++) {
                    if(boundRect[i].height > 100){
                        System.out.println("i:"+ i + " Height: " + boundRect[i].height);
                        if(boundRect[i].width > 300){
                            areaCounter++;
                            System.out.println("i:"+ i + " Width: " +  boundRect[i].width);
                            Imgproc.rectangle(rectOutput, boundRect[i].tl(), boundRect[i].br(), new Scalar(255, 0, 0), 20);
                        }
                    }
                }


                imageViewer("4000 Rect found", rectOutput);
                System.out.println(areaCounter);



            }
            //ClassfierComparsion - Reset after david chat
            if(CODE_VERSION == 91){
                System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
                Pair returnVariables = new Pair();
                int areaCounter=0;


                //Mat original = Imgcodecs.imread(filename, Imgcodecs.IMREAD_GRAYSCALE);
                //Mat binarized = original.clone();
                //Mat mid = new Mat();
                //if(borderCrop > 0){
                    //Imgproc.adaptiveThreshold(original, mid,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, 2);
                    //double maxX = mid.size().width;
                    //double maxY = mid.size().height;
                    //Point cp1 = new Point(maxX/10, maxY/10);
                    //Point cp2 = new Point(maxX - cp1.x, maxY -cp1.y);
                    //Rect rectCrop = new Rect(cp1, cp2);
                    //binarized = mid.submat(rectCrop);
                //}
                //else{
                //Imgproc.adaptiveThreshold(original, binarized,255, Imgproc.ADAPTIVE_THRESH_GAUSSIAN_C,Imgproc.THRESH_BINARY_INV, 15, THRESHOLD_C);
                //}


                try{
                    //************************************
                    //1. Large Object Remover
                    //************************************
                    Mat srcLOR = binarized.clone();
                    Mat maskLOR = new Mat();
                    Mat dstLOR = new Mat();

                    //Remove small objects in prep for masking  (De-Noise)
                    Mat removeSmallLOR = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(5,5));
                    Imgproc.morphologyEx(srcLOR,maskLOR, Imgproc.MORPH_OPEN, removeSmallLOR);

                    //Heal the large items
                    Mat healLOR = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(25,25));
                    Imgproc.morphologyEx(maskLOR,maskLOR, Imgproc.MORPH_CLOSE, healLOR);

                    //IsolateLarge
                    Mat isolateLargeLOR = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(30,30));
                    Imgproc.morphologyEx(maskLOR,maskLOR, Imgproc.MORPH_OPEN, isolateLargeLOR);

                    Core.bitwise_not(maskLOR,maskLOR);
                    srcLOR.copyTo(dstLOR, maskLOR);

                    Mat base = binarized.clone();
                    //***********************************
                    //3. Isolate straight lines
                    //***********************************
                    //Heal lines
                    Mat healISL = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(82,1));
                    Imgproc.morphologyEx(dstLOR,base, Imgproc.MORPH_OPEN, healISL);

                    //Make White Blobs
                    Mat kernelOpen = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(4,1));
                    Imgproc.morphologyEx(base,base,Imgproc.MORPH_OPEN, kernelOpen);

                    Mat kernelDilateAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(1,10));
                    Imgproc.dilate(base, base, kernelDilateAgain);

                    Mat kernelCloseAgain = Imgproc.getStructuringElement(Imgproc.MORPH_RECT, new Size(12,50));
                    Imgproc.morphologyEx(base,base,Imgproc.MORPH_CLOSE, kernelCloseAgain);

                    //***********************************
                    //4. Find 'Clusters'
                    //   Need to find areas, using bounding boxes
                    //   Find how tall the bounding box is, if its taller than 'x' then classify as Sheet Music
                    //***********************************

                    //*****************************************************************
                    //4.1 Prep Rectangles on processed images
                    //*****************************************************************
                    ArrayList<MatOfPoint> contours = new ArrayList<MatOfPoint>();
                    Mat hierarchy = new Mat();
                    Imgproc.findContours(base, contours, hierarchy, Imgproc.RETR_EXTERNAL, Imgproc.CHAIN_APPROX_SIMPLE);
                    //Draw contours and record areas
                    Mat allContoursFound = Mat.zeros(base.size(), CvType.CV_8UC3);
                    Imgproc.drawContours(allContoursFound, contours, -1, new Scalar(0, 255, 0), 1); //USES LINE_8
                    //Init arrays
                    MatOfPoint2f[] contoursPoly  = new MatOfPoint2f[contours.size()];
                    Rect[] boundRect = new Rect[contours.size()];

                    //Fill arrays
                    for (int i = 0; i < contours.size(); i++) {
                        contoursPoly[i] = new MatOfPoint2f();
                        Imgproc.approxPolyDP(new MatOfPoint2f(contours.get(i).toArray()), contoursPoly[i], 1, true);
                        boundRect[i] = Imgproc.boundingRect(new MatOfPoint(contoursPoly[i].toArray()));
                    }
                    //Draw circle for each large contour
                    //MAKE THE COMPARING VALUES GLOBAL CONSTANTS
                    for (int i = 0; i < contours.size(); i++) {
                        if(boundRect[i].height > 100){
                            if(boundRect[i].width > 300){
                                areaCounter++;
                            }
                        }
                    }

                    //Classifier Calculation
                    if(areaCounter >= THRESHOLD_AREA_COUNT){
                        returnVariables.setBoolean(true);
                        returnVariables.setInteger(areaCounter);
                    }
                }
                catch(Exception e){
                    System.err.println(e);
                }
                //return returnVariables;
            }

            //****************MORPHOLOGY****************************************************************************************

            //BufferedImage toBeClassifiedImg = toBufferedImage(edgesDetectedRGB);

            //Display Results
            //HighGui.imshow("Source", original);
            //HighGui.imshow("Just Edges", justEdges); //TESTING


            //imshow("LINESFOUND", edgesDetectedRGB);
            //HighGui.resizeWindow("LINESFOUND", 1000,1000);
            
            //HighGui.imshow("CLUSTERS FOUND", clustersFoundRGB);
            //HighGui.imshow("Detected Lines (in red) - negative", edgesDetectedRGBProb);

            //COUNT OF LINES CLASSIFICATION
            //System.out.println("LINE CLUSTER RESULT: " +  ClassifierLineClusterOLD(toBeClassifiedImg).get(0) + '\t' + "LinesFound: " + ClassifierLineClusterOLD(toBeClassifiedImg).get(1) + '\t' + "ClustersFound: " + ClassifierLineClusterOLD(toBeClassifiedImg).get(2));
            //System.out.println("NEW CLUSTER RESULTS: " +  ClassifierLineClusterPt(pointArrayList,clustersFoundRGB).get(0) + '\t' + "LinesFound: " + horizontalLineCount + '\t' + "ClustersFound: " + ClassifierLineClusterPt(pointArrayList,clustersFoundRGB).get(1));
            //System.out.println(ClassifierLineClusterPt(pointArrayList, clustersFoundRGB));

            //System.out.println("TEST: " + LineCountOrCluster(horizontalLineCount, pointArrayList, clustersFoundRGB));

            // Wait and Exit
            //HighGui.waitKey();
            System.exit(0);
        }
        catch(Exception e){
            System.err.println(e);
        }
    }
}
